﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Net.Sockets;

namespace CeucMessenger
{
    /// <summary>
    /// Logique d'interaction pour CeucMessengerWindow.xaml
    /// </summary>
    public partial class CeucMessengerWindow : Window
    {
        public CeucMessengerWindow()
        {
            InitializeComponent();
            //FormClosing += Form1_FormClosing;
        }

        const int portNo = 500;
        TcpClient client;

        byte[] data;
        private void btnSend_Click(System.Object sender, System.EventArgs e)
        {
            SendMessage(this.txtMessage.Text);
            txtMessage.Clear();
        }

        public void SendMessage(string message)
        {
            try
            {
                //---send a message to the server
                NetworkStream ns = client.GetStream();
                byte[] data = System.Text.Encoding.ASCII.GetBytes(message);
                //---send the text---
                ns.Write(data, 0, data.Length);
                ns.Flush();
            }
            catch (Exception ex)
            {
                MessageBox.Show(this,ex.ToString());
            }
        }

        public void ReceiveMessage(IAsyncResult ar)
        {
            try
            {
                int bytesRead = 0;
                bytesRead = client.GetStream().EndRead(ar);
                if (bytesRead < 1)
                {
                    return;
                }
                else
                {
                    object[] para = { System.Text.Encoding.ASCII.GetString(data, 0, bytesRead) };
                    this.Invoke(new delUpdateHistory(this.UpdateHistory), para);
                }
                client.GetStream().BeginRead(data, 0, Convert.ToInt32(client.ReceiveBufferSize), ReceiveMessage, null);
            }
            catch (Exception ex)
            {
            }
        }

        private void btnSignIn_Click(System.Object sender, System.EventArgs e)
        {
            if (btnSignIn.Text == "Sign In")
            {
                try
                {
                    //---connect to server
                    client = new TcpClient();
                    client.Connect("127.0.0.1", portNo);
                    data = new byte[client.ReceiveBufferSize + 1];
                    SendMessage(txtNick.Text);
                    //---read from server
                    client.GetStream().BeginRead(data, 0, Convert.ToInt32(client.ReceiveBufferSize), ReceiveMessage, null);
                    btnSignIn.Text = "Sign Out";
                    btnSend.Enabled = true;
                }
                catch (Exception ex)
                {
                    MessageBox.Show(this, ex.ToString());
                }
            }
            else
            {
                //---disconnect from server
                Disconnect();
                btnSignIn.Text = "Sign In";
                btnSend.Enabled = false;
            }
        }

        public void Disconnect()
        {
            //---Disconnect from server
            try
            {
                client.GetStream().Close();
                client.Close();
            }
            catch (Exception ex)
            {
                Interaction.MsgBox(ex.ToString());
            }
        }

        //---delegate and subroutine to update the TextBox control
        public delegate void delUpdateHistory(string str);
        public void UpdateHistory(string str)
        {
            txtMessageHistory.AppendText(str);
        }

        private void Form1_FormClosing(object sender, System.Windows.Forms.FormClosingEventArgs e)
        {
            Disconnect();
        }

        
    }
}