﻿using SimplyMessengerLibrary;
using System;
using System.Collections;
using System.Net.Sockets;

namespace SimplyMsgServerConsole
{
    class ChatClient
    {
        //---contains a list of all the clients

        public static Hashtable AllClients = new Hashtable();
        //---information about the client
        private TcpClient _client;
        private string _clientIP;

        private string _ClientNick;
        //---used for sending/receiving data

        private byte[] data;
        //---is the nick name being sent?

        private bool ReceiveNick = true;
        public ChatClient(TcpClient client)
        {
            _client = client;

            //---get the client IP address
            _clientIP = client.Client.RemoteEndPoint.ToString();

            //---add the current client to the hash table
            AllClients.Add(_clientIP, this);

            //---start reading data from the client in a separate thread
            data = new byte[_client.ReceiveBufferSize + 1];
            _client.GetStream().BeginRead(data, 0, Convert.ToInt32(_client.ReceiveBufferSize), ReceiveMessage, null);
        }

        public void SendMessage(string message)
        {
            SerializationHelper sh = new SerializationHelper();
            //Message mess = new Message(;
            //sh.Serialization("toto.txt", message);
            try
            {
                //---send the text
                System.Net.Sockets.NetworkStream ns = null;
                lock (_client.GetStream())
                {
                    ns = _client.GetStream();
                }
                byte[] bytesToSend = System.Text.Encoding.Unicode.GetBytes(message);
                ns.Write(bytesToSend, 0, bytesToSend.Length);
                ns.Flush();
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
            }
        }

        public void ReceiveMessage(IAsyncResult ar)
        {
            //---read from client---
            int bytesRead = 0;
            string path;
            try
            {
                lock (_client.GetStream())
                {
                    bytesRead = _client.GetStream().EndRead(ar);
                }
                //---client has disconnected
                if (bytesRead < 1)
                {
                    AllClients.Remove(_clientIP);
                    Broadcast(_ClientNick);
                    return;
                }
                else
                {
                    SerializationHelper sh = new SerializationHelper();
                    FileHelper fh = new FileHelper();
                    //---get the message sent
                    string messageReceived = System.Text.Encoding.Unicode.GetString(data, 0, bytesRead);
                    //---client is sending its nickname
                    Message message = new Message();
                    Random rnd = new Random();
                    path = "Client_" + rnd.Next()  + ".txt";
                    fh.FileWrite(path, messageReceived);
                    

                    message = sh.Deserialization(path);
                    if (ReceiveNick)
                    {
                        _ClientNick = messageReceived;

                        //---tell everyone client has entered the chat
                        Broadcast(_ClientNick);
                        ReceiveNick = false;
                    }
                    else
                    {
                        //---broadcast the message to everyone
                        Broadcast(messageReceived);
                    }
                }
                //---continue reading from client
                lock (_client.GetStream())
                {
                    _client.GetStream().BeginRead(data, 0, Convert.ToInt32(_client.ReceiveBufferSize), ReceiveMessage, null);
                }
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.ToString());
                AllClients.Remove(_clientIP);
                Broadcast(_ClientNick);
            }
        }

        public void Broadcast(string message)
        {
            //---log it locally
            Console.Clear();
            foreach (DictionaryEntry de in AllClients)
            {
                Console.WriteLine(de.Key);
            }
            Console.WriteLine("---");
            Console.WriteLine(message);
            DictionaryEntry c = default(DictionaryEntry);
            foreach (DictionaryEntry c_loopVariable in AllClients)
            {
                
                c = c_loopVariable;
                //---broadcast message to all users
                ((ChatClient)c.Value).SendMessage(message + "\n");
            }
        }
    }
}
