﻿using SimplyMessengerLibrary;
using System;
using System.Diagnostics;
using System.Net;
using System.Net.Sockets;

namespace SimplyMsgServerConsole
{
    class SimplyMsgServer
    {
        const int portNo = 500;
        static System.Net.IPAddress localAdd = System.Net.IPAddress.Parse(getAddr());

        static TcpListener listener = new TcpListener(localAdd, portNo);

        /// <summary>
        /// Get the local IP Server Address (192.*.*.*)
        /// </summary>
        /// <returns>(String) IP Address</returns>
        static string getAddr()
        {
            string hn = System.Net.Dns.GetHostName();
            IPAddress[] ipadress = Dns.GetHostAddresses(hn);
            foreach (var add in ipadress)
            {
                string adr_string = add.ToString();
                if (adr_string.Substring(0, 3) == "192")
                    return adr_string.ToString();
            }
            return "127.0.0.1";
        }

        public static void Main(string[] args)
        {
            FileHelper fh = new FileHelper();
            fh.EraseAllTxtFiles();
            if (IsAlreadyLaunched())
                Environment.Exit(0);
            
            if ((Environment.GetCommandLineArgs()).Length == 2)
                localAdd = IPAddress.Parse(args[0]);

            listener.Start();
            WelcomeMessage(localAdd.ToString());
            while (true)
            {
                ChatClient user = new ChatClient(listener.AcceptTcpClient());
            }
        }

        /// <summary>
        /// Return TRUE is the server is already launched
        /// </summary>
        /// <returns>bool</returns>
        static bool IsAlreadyLaunched()
        {
            int processCount = 0;
            string assemblyName = System.Reflection.Assembly.GetEntryAssembly().GetName().Name;
            Process[] processlist = Process.GetProcesses();

            foreach (Process theprocess in processlist)
            {
                if (theprocess.ProcessName == assemblyName || theprocess.ProcessName == assemblyName + ".vshost")
                    processCount++;

                if (processCount == 2)
                    return true;
            }

            return false;
        }

        static void WelcomeMessage(string address)
        { Console.WriteLine("The server IP is " + localAdd); }
    }
}